## blacs-mpi 1.1

=== Makefile ===
help :
	@ echo
	@ echo "Make sure you are using the correct Bmake.inc for your system."
	@ echo "At this level, assuming you have downloaded the necessary files,"
	@ echo "you may make the BLACS tester (make tester), or one of the BLACS"
	@ echo "versions (make cmmd, make mpl, make nx, or make pvm)"
	@ echo "You can define the make macro 'what' to perform a specific action."
	@ echo "(eg., make tester what=clean)"
	@ echo "There are short README files in TESTING/ and SRC/."
	@ echo

all : mpi cmmd mpl nx pvm tester

cleanall:
	( cd TESTING ; make clean )
	( cd SRC/CMMD ; make clean )
	( cd SRC/MPL  ; make clean )
	( cd SRC/NX   ; make clean )
	( cd SRC/PVM  ; make clean )

testing: tester
xbtest : tester
test   : tester
tester :
	( cd TESTING ; make $(what) )

CM5  : CMMD
cmmd : CMMD
CMMD :
	( cd SRC/CMMD ; make $(what) )

SP1 : MPL
SP2 : MPL
mpl : MPL
MPL :
	( cd SRC/MPL ; make $(what) )

intel   : NX
ipsc2   : NX
i860    : NX
delta   : NX
gamma   : NX
paragon : NX
nx      : NX
NX :
	( cd SRC/NX ; make $(what) )

pvm : PVM
PVM :
	( cd SRC/PVM ; make $(what) )

mpi : MPI
MPI :
	( cd SRC/MPI ; make $(what) )

=== INSTALL/EXE/Makefile ===
xsize : 
	( cd ../ ; make xsize )
xintface :
	( cd ../ ; make xintface )
xsyserrors :
	( cd ../ ; make xsyserrors )
xtranscomm :
	( cd ../ ; make xtranscomm )
xmpi_sane  :
	( cd ../ ; make xmpi_sane )
xfmpi_sane  :
	( cd ../ ; make xfmpi_sane )
xtc_CsameF77:
	( cd ../ ; make xtc_CsameF77 )
xtc_UseMpich:
	( cd ../ ; make xtc_UseMpich )
clean:
	( cd ../ ; make clean )

=== SRC/MPI/Makefile ===
dlvl = ../..
include $(dlvl)/Bmake.inc

#  --------------------------
#  The communication routines
#  --------------------------
comm = igesd2d_.o sgesd2d_.o dgesd2d_.o cgesd2d_.o zgesd2d_.o \
       itrsd2d_.o strsd2d_.o dtrsd2d_.o ctrsd2d_.o ztrsd2d_.o \
       igerv2d_.o sgerv2d_.o dgerv2d_.o cgerv2d_.o zgerv2d_.o \
       itrrv2d_.o strrv2d_.o dtrrv2d_.o ctrrv2d_.o ztrrv2d_.o \
       igebs2d_.o sgebs2d_.o dgebs2d_.o cgebs2d_.o zgebs2d_.o \
       igebr2d_.o sgebr2d_.o dgebr2d_.o cgebr2d_.o zgebr2d_.o \
       itrbs2d_.o strbs2d_.o dtrbs2d_.o ctrbs2d_.o ztrbs2d_.o \
       itrbr2d_.o strbr2d_.o dtrbr2d_.o ctrbr2d_.o ztrbr2d_.o \
       igsum2d_.o sgsum2d_.o dgsum2d_.o cgsum2d_.o zgsum2d_.o \
       igamx2d_.o sgamx2d_.o dgamx2d_.o cgamx2d_.o zgamx2d_.o \
       igamn2d_.o sgamn2d_.o dgamn2d_.o cgamn2d_.o zgamn2d_.o

#  -----------------------------------------------------------------------------
#  These names are too long for the archiver to distinguish based on the suffix.
#  I'm going to use logical links to get around this problem.  It's hokey, but
#  it lets us use the suffix rule and keep the makefile portable.
#  -----------------------------------------------------------------------------
long = blacs_gridinit_.o blacs_gridmap_.o blacs_freebuff_.o \
       blacs_gridexit_.o blacs_gridinfo_.o blacs_barrier_.o \
       sys2blacs_handle_.o free_blacs_system_handle_.o \
       blacs2sys_handle_.o

Clong = Cblacs_gridinit_.C Cblacs_gridmap_.C Cblacs_freebuff_.C \
        Cblacs_gridexit_.C Cblacs_gridinfo_.C Cblacs_barrier_.C \
        Csys2blacs_handle_.C Cfree_blacs_system_handle_.C \
        Cblacs2sys_handle_.C

#  --------------------
#  The support routines
#  --------------------
supp = blacs_setup_.o blacs_set_.o blacs_get_.o \
       blacs_abort_.o blacs_exit_.o blacs_pnum_.o blacs_pcoord_.o \
       ksendid_.o krecvid_.o kbsid_.o kbrid_.o \
       dcputime00_.o dwalltime00_.o

#  ----------------------------
#  The fortran and C interfaces
#  ----------------------------
Fintobj   = $(comm) $(supp) $(long)
Cintobj   = $(comm:.o=.C) $(supp:.o=.C) $(Clong)

#  ---------------------
#  The internal routines
#  ---------------------
internal = BI_HypBS.o BI_HypBR.o BI_IdringBS.o BI_IdringBR.o \
           BI_MpathBS.o BI_MpathBR.o BI_SringBS.o BI_SringBR.o \
           BI_TreeBS.o BI_TreeBR.o \
           BI_Ssend.o BI_Rsend.o BI_Srecv.o BI_Asend.o BI_Arecv.o \
           BI_TreeComb.o BI_BeComb.o BI_MringComb.o \
           BI_ArgCheck.o BI_TransDist.o BI_GetBuff.o BI_UpdateBuffs.o \
           BI_EmergencyBuff.o BI_BlacsErr.o BI_BlacsWarn.o BI_BlacsAbort.o \
           BI_BuffIsFree.o BI_imvcopy.o BI_smvcopy.o BI_dmvcopy.o \
           BI_ivmcopy.o BI_svmcopy.o BI_dvmcopy.o \
           BI_Pack.o BI_Unpack.o BI_GetMpiGeType.o BI_GetMpiTrType.o \
           BI_ivvsum.o BI_svvsum.o BI_dvvsum.o BI_cvvsum.o BI_zvvsum.o \
           BI_ivvamx.o BI_svvamx.o BI_dvvamx.o BI_cvvamx.o BI_zvvamx.o \
           BI_ivvamx2.o BI_svvamx2.o BI_dvvamx2.o BI_cvvamx2.o BI_zvvamx2.o \
           BI_ivvamn.o BI_svvamn.o BI_dvvamn.o BI_cvvamn.o BI_zvvamn.o \
           BI_ivvamn2.o BI_svvamn2.o BI_dvvamn2.o BI_cvvamn2.o BI_zvvamn2.o \
           BI_iMPI_amx.o BI_sMPI_amx.o BI_dMPI_amx.o BI_cMPI_amx.o \
           BI_zMPI_amx.o BI_iMPI_amx2.o BI_sMPI_amx2.o BI_dMPI_amx2.o \
           BI_cMPI_amx2.o BI_zMPI_amx2.o BI_iMPI_amn.o BI_sMPI_amn.o \
           BI_dMPI_amn.o BI_cMPI_amn.o BI_zMPI_amn.o BI_iMPI_amn2.o \
           BI_sMPI_amn2.o BI_dMPI_amn2.o BI_cMPI_amn2.o BI_zMPI_amn2.o \
           BI_cMPI_sum.o BI_zMPI_sum.o BI_ContxtNum.o BI_GlobalVars.o \
           BI_MPI_F77_to_c_trans_comm.o BI_MPI_C_to_f77_trans_comm.o \
           BI_TransUserComm.o bi_f77_mpi_attr_get.o bi_f77_mpi_op_create.o \
           bi_f77_mpi_initialized.o bi_f77_mpi_test.o bi_f77_mpi_testall.o \
           bi_f77_get_constants.o

lib : all
f77lib : flib
F77lib : flib
Clib : clib

#  ---------------------------------------
#  Make both C and fortran interface BLACS
#  ---------------------------------------
all : INTERN $(Fintobj) $(Cintobj)
	rm -f $(BLACSFINIT) $(BLACSCINIT)
	make $(BLACSFINIT)
	make $(BLACSCINIT)
	$(ARCH) $(ARCHFLAGS) $(BLACSLIB) $(Fintobj) $(Cintobj)
	$(RANLIB) $(BLACSLIB)

$(BLACSFINIT) :
	$(CC) -o Cblacs_pinfo.o -c $(CCFLAGS) $(BLACSDEFS) -DCallFromC -DMainInF77 \
                 blacs_pinfo_.c
	$(CC) -c $(CCFLAGS) $(BLACSDEFS) -DMainInF77 blacs_pinfo_.c
	$(ARCH) $(ARCHFLAGS) $(BLACSFINIT) blacs_pinfo_.o Cblacs_pinfo.o
	$(RANLIB) $(BLACSFINIT)

$(BLACSCINIT) :
	$(CC) -o Cblacs_pinfo.o -c $(CCFLAGS) $(BLACSDEFS) -DCallFromC -DMainInC \
                 blacs_pinfo_.c
	$(CC) -c $(CCFLAGS) $(BLACSDEFS) -DMainInC blacs_pinfo_.c
	$(ARCH) $(ARCHFLAGS) $(BLACSCINIT) blacs_pinfo_.o Cblacs_pinfo.o
	$(RANLIB) $(BLACSCINIT)

#  ------------------
#  Make the internals
#  ------------------
INTERN :
	( cd INTERNAL ; $(MAKE) -f ../Makefile I_int "dlvl=$(BTOPdir)" )

I_int : Bdef.h Bconfig.h $(internal)
	$(ARCH) $(ARCHFLAGS) $(BLACSLIB) $(internal)

Bdef.h : ../Bdef.h
	rm -f Bdef.h
	ln -s ../Bdef.h Bdef.h

Bconfig.h : ../Bconfig.h
	rm -f Bconfig.h
	ln -s ../Bconfig.h Bconfig.h

#  -----------------------
#  Delete the object files
#  -----------------------
clean :
	rm -f $(Cintobj) $(Fintobj) $(long:.o=.C)
	rm -f blacs_pinfo_.o Cblacs_pinfo.o
	( cd INTERNAL ; rm -f bi_f77_get_constants.o bi_f77_mpi_attr_get.o \
                              bi_f77_mpi_initialized.o bi_f77_mpi_op_create.o \
                              bi_f77_mpi_test.o bi_f77_mpi_testall.o \
                              Bdef.h Bconfig.h mpif.h )
	( cd INTERNAL ; rm -f $(internal) )

#  -------------------------------------
#  Delete the library, object and source
#  -------------------------------------
killib :
	$(MAKE) clean
	rm -f $(Fintobj:.o=.c) Bdef.h Bconfig.h
	rm -f blacs_pinfo_.c
	( cd INTERNAL ; rm -f $(internal:.o=.c) Bdef.h Bconfig.h )
	( cd INTERNAL ; rm -f bi_f77_get_constants.f bi_f77_mpi_attr_get.f \
                              bi_f77_mpi_initialized.f bi_f77_mpi_op_create.f \
                              bi_f77_mpi_test.f bi_f77_mpi_testall.f mpif.h )

#  -------------------------------------------------------------------------
#  Establish how to make logical links to the long-name C interface routines
#  that are distinct in first 13 characters from their Fortran interface 
#  equivalents.
#  -------------------------------------------------------------------------
Cblacs_gridinit_.C : blacs_gridinit_.C
	rm -f Cblacs_gridinit_.C
	ln -s blacs_gridinit_.C Cblacs_gridinit_.C
Cblacs_gridinfo_.C : blacs_gridinfo_.C
	rm -f Cblacs_gridinfo_.C
	ln -s blacs_gridinfo_.C Cblacs_gridinfo_.C
Cblacs_gridexit_.C : blacs_gridexit_.C
	rm -f Cblacs_gridexit_.C
	ln -s blacs_gridexit_.C Cblacs_gridexit_.C
Cblacs_gridmap_.C : blacs_gridmap_.C
	rm -f Cblacs_gridmap_.C
	ln -s blacs_gridmap_.C Cblacs_gridmap_.C
Cblacs_freebuff_.C : blacs_freebuff_.C
	rm -f Cblacs_freebuff_.C
	ln -s blacs_freebuff_.C Cblacs_freebuff_.C
Cblacs_barrier_.C : blacs_barrier_.C
	rm -f Cblacs_barrier_.C
	ln -s blacs_barrier_.C Cblacs_barrier_.C
Csys2blacs_handle_.C : sys2blacs_handle_.C
	rm -f Csys2blacs_handle_.C
	ln -s sys2blacs_handle_.C Csys2blacs_handle_.C
Cblacs2sys_handle_.C : blacs2sys_handle_.C
	rm -f Cblacs2sys_handle_.C
	ln -s blacs2sys_handle_.C Cblacs2sys_handle_.C
Cfree_blacs_system_handle_.C : free_blacs_system_handle_.C
	rm -f Cfree_blacs_system_handle_.C
	ln -s free_blacs_system_handle_.C Cfree_blacs_system_handle_.C

#  -------------------------------------
#  Compile the (ouch!) fortran internals
#  -------------------------------------
bi_f77_get_constants.o : mpif.h bi_f77_get_constants.f
	$(F77) -c $(F77FLAGS) $*.f
bi_f77_mpi_attr_get.o : mpif.h bi_f77_mpi_attr_get.f
	$(F77) -c $(F77FLAGS) $*.f
bi_f77_mpi_initialized.o : mpif.h bi_f77_mpi_initialized.f
	$(F77) -c $(F77FLAGS) $*.f
bi_f77_mpi_op_create.o : mpif.h bi_f77_mpi_op_create.f
	$(F77) -c $(F77FLAGS) $*.f
bi_f77_mpi_test.o : mpif.h bi_f77_mpi_test.f
	$(F77) -c $(F77FLAGS) $*.f
bi_f77_mpi_testall.o : mpif.h bi_f77_mpi_testall.f
	$(F77) -c $(F77FLAGS) $*.f

mpif.h : $(MPIINCdir)/mpif.h
	rm -f mpif.h
	ln -s $(MPIINCdir)/mpif.h mpif.h

#  ------------------------------------------------------------------------
#  We move C .o files to .C so that we can use the portable suffix rule for
#  compilation, and still have them coexist with the fortran interface
#  .o files.
#  ------------------------------------------------------------------------
.SUFFIXES: .o .C
.c.C:
	$(CC) -o C$*.o -c $(CCFLAGS) $(BLACSDEFS) -DCallFromC $<
	mv C$*.o $*.C
.c.o:
	$(CC) -c $(CCFLAGS) $(BLACSDEFS) $<

=== debian/changelog ===
blacs-mpi (1.1-40build1) artful; urgency=medium

  * No-change rebuild for libgfortran soname change.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 04 Aug 2017 17:17:20 +0000

blacs-mpi (1.1-40) unstable; urgency=medium

  * Team upload.
  * update debian/control: +powerpcspe -mips64 -sparc

 -- Drew Parsons <dparsons@debian.org>  Sun, 11 Jun 2017 13:20:40 +0800

blacs-mpi (1.1-39) unstable; urgency=medium

  * Team upload.
  * Now team-maintained by Debian Science.
  * Update list of OpenMPI arches
    (in line with /usr/share/mpi-default-dev/debian_defaults):
    - add powerpcspe
    - remove mips64, sparc
    - Closes: #850779.
  * Use multiarch lib directories. Closes: #722755.
  * Source format 3.0 (quilt).
  * debian/compat 9
  * Standards-Version: 3.9.8
  * VCS (git repository) now at
    https://anonscm.debian.org/cgit/debian-science/packages/blacs-mpi.git/

 -- Drew Parsons <dparsons@debian.org>  Sun, 11 Jun 2017 12:43:48 +0800

blacs-mpi (1.1-38) unstable; urgency=medium

  * /usr/lib/openmpi path in debian/blacs-mpi-implementations.patch  was
    replaced with the correct triplet path. Thanks to Gilles Filippini for
    providing a patch (Closes: #848813)

 -- Muammar El Khatib <muammar@debian.org>  Sat, 25 Mar 2017 13:10:54 -0400

blacs-mpi (1.1-37) unstable; urgency=medium

  * This revision is not running tests for i386, alpha, sh4. This avoids them
    to FTBFS because of this error: `Build killed with signal TERM after 150
    minutes of inactivity`.

 -- Muammar El Khatib <muammar@debian.org>  Wed, 24 Aug 2016 17:33:47 +0200

blacs-mpi (1.1-36) unstable; urgency=medium

  * Missing separator added in debian/rules making the package FTBFS in some
    architectures.

 -- Muammar El Khatib <muammar@debian.org>  Sat, 20 Aug 2016 19:09:24 +0200

blacs-mpi (1.1-35) unstable; urgency=medium

  * Added a conditional in debian/rules for some architectures suffering from
    `Build killed with signal TERM after 150 minutes of inactivity`.

 -- Muammar El Khatib <muammar@debian.org>  Sat, 20 Aug 2016 18:15:15 +0200

blacs-mpi (1.1-34) unstable; urgency=medium

  * hppa architecture has been switched from mpich to openmpi (Closes:
    #834181).
  * "build-arch" and "build-indep" targets addedin debian/rules. Thanks to
    Santiago Vila  for providing a patch (Closes: #821968).
  * Now the package runs testsuite. Thanks to Michael Banck for providing
    a patch (Closes: #816347, #813551).

 -- Muammar El Khatib <muammar@debian.org>  Mon, 15 Aug 2016 14:41:06 +0200

blacs-mpi (1.1-33.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Update the list of MPI architectures:
    + switch s390x from mpich to OpenMPI.
    + switch sparc64 from mpich to OpenMPI.
    + add x32 to OpenMPI.
    + add sh4 to mpich.
    + drop powerpcspe.
    + Closes: #814150

 -- Mattia Rizzolo <mattia@debian.org>  Wed, 10 Feb 2016 17:47:00 +0000

blacs-mpi (1.1-33.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Use `pkg-config mpi-fort --libs` rather than hard-coded libs for
    openmpi.  Patch from Alastair McKinstry <mckinstry@debian.org>.
    Closes: #813490

 -- Mattia Rizzolo <mattia@debian.org>  Wed, 03 Feb 2016 08:44:20 +0000

blacs-mpi (1.1-33.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Link the mpich based library against the libmpich and libmpichfort.
    Closes: #811229.
  * Remove ppc64 from the list of mpich architectures.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 18 Jan 2016 19:33:39 +0100

blacs-mpi (1.1-33) unstable; urgency=medium

  * Moving arm64 from MPICH_ARCHS to OPENMPI_ARCHS. In this way, the package
    builds correctly in arm64. Thanks to Edmund Grimley Evans. (Closes: #765328)

 -- Muammar El Khatib <muammar@debian.org>  Fri, 17 Oct 2014 10:12:28 +0200

blacs-mpi (1.1-32) unstable; urgency=medium

  * mips64 and mips64el were marked as openmpi archs. (Closes: #761946)

 -- Muammar El Khatib <muammar@debian.org>  Tue, 23 Sep 2014 14:42:00 +0200

blacs-mpi (1.1-31.4) unstable; urgency=medium

  * Non-maintainer upload.
  * Add arm64, ppc64 and ppc64el to the openmpi architectures.
  * Build OpenMPI with -DUseMpi2. Closes: #714583.
  * debian/rules: declare library dependencies correctly. Closes: #660214.

 -- Matthias Klose <doko@debian.org>  Wed, 06 Aug 2014 22:57:32 +0200

blacs-mpi (1.1-31.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Drop transitional package libblacs-mpi1: it breaks reverse
    dependencies on mpich archs, because of the mpich2->mpich transition.

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 23 Apr 2014 14:33:08 +0200

blacs-mpi (1.1-31.2) unstable; urgency=medium

  * Non-maintainer upload.
  * No longer silently change the SONAME of the MPI blacs shared
    library when the default MPI implementation changes on a given arch.
    (Closes: #740764)
    + Create two new binary packages libblacs-openmpi1 and
      libblacs-mpich1, corresponding to the two possible SONAMES.
    + The architecture list for each binary package is stored in debian/rules,
      and debian/control is now generated from debian/control.in by the clean
      rule.
    + Keep a transitional package for libblacs-mpi1.
    + Make sure that the package FTBFS if the default MPI implementation
      changes on a given arch (instead of silently changing the SONAME or
      creating an empty package).

 -- Sébastien Villemot <sebastien@debian.org>  Thu, 03 Apr 2014 16:31:07 +0200

blacs-mpi (1.1-31.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Support MPICH3 which is now simply called MPICH. (Closes: #731225)

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 22 Dec 2013 13:25:27 +0000

blacs-mpi (1.1-31) unstable; urgency=low

  * Rebuilding with mpi-default-dev >=1.0 (Closes: #652312)

 -- Muammar El Khatib <muammar@debian.org>  Fri, 23 Dec 2011 20:40:53 +0100

blacs-mpi (1.1-30.1) unstable; urgency=low

  * Non-maintainer upload.
  * Add support for ARCH_DEFAULT_MPI_IMPL from mpi-default-dev.


=== debian/control ===
# This file is autogenerated. DO NOT EDIT!
#
# Modifications should be made to debian/control.in instead.
# This file is regenerated automatically in the clean target.

Source: blacs-mpi
Section: devel
Priority: extra
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Muammar El Khatib <muammar@debian.org>
Standards-Version: 3.9.8
Build-Depends: debhelper (>= 7), dh-exec, mpi-default-dev (>= 1.0), mpi-default-bin, gfortran, pkg-config
Homepage: http://www.netlib.org/blacs/
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/blacs-mpi.git
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/blacs-mpi.git/

Package: libblacs-openmpi1
Section: libs
Architecture: alpha amd64 arm64 armel armhf hppa hurd-i386 i386 kfreebsd-amd64 kfreebsd-i386 mips mips64el mipsel powerpc powerpcspe ppc64 ppc64el s390x sparc64 x32
Depends: mpi-default-bin, ${shlibs:Depends}, ${misc:Depends}
Breaks: libblacs-mpi1 (<< 1.1-31.2)
Replaces: blacs1-mpich, blacs1gf-mpich, blacs1-lam, blacs1gf-lam,
          libblacs-mpi1 (<< 1.1-31.2)
Conflicts: blacs1-mpich, blacs1gf-mpich, blacs1-lam, blacs1gf-lam
Description: Basic Linear Algebra Comm. Subprograms - Shared libs. for OpenMPI
 The BLACS project is an ongoing investigation whose purpose is to
 create a linear algebra oriented message passing interface that may be
 implemented efficiently and uniformly across a large range of
 distributed memory platforms.
 .
 You can choose between an implementation based on MPI or PVM. This package
 uses MPI. There are packages for the shared libraries (this one), for the
 static libraries and the development files, and for test programs.
 .
 Most users do not need to install this package directly because it is
 used as a high level driver for the communication in the ScaLAPACK packages.
 Therefore, it is installed when installing ScaLAPACK. ScaLAPACK is a
 parallel version of LAPACK and is used on Beowulf type clusters.

Package: libblacs-mpich1
Section: libs
Architecture: m68k sh4
Depends: mpi-default-bin, ${shlibs:Depends}, ${misc:Depends}
Breaks: libblacs-mpi1 (<< 1.1-31.2)
Replaces: blacs1-mpich, blacs1gf-mpich, blacs1-lam, blacs1gf-lam,
          libblacs-mpi1 (<< 1.1-31.2)
Conflicts: blacs1-mpich, blacs1gf-mpich, blacs1-lam, blacs1gf-lam
Description: Basic Linear Algebra Comm. Subprograms - Shared libs. for MPICH
 The BLACS project is an ongoing investigation whose purpose is to
 create a linear algebra oriented message passing interface that may be
 implemented efficiently and uniformly across a large range of
 distributed memory platforms.
 .
 You can choose between an implementation based on MPI or PVM. This package
 uses MPI. There are packages for the shared libraries (this one), for the
 static libraries and the development files, and for test programs.
 .
 Most users do not need to install this package directly because it is
 used as a high level driver for the communication in the ScaLAPACK packages.
 Therefore, it is installed when installing ScaLAPACK. ScaLAPACK is a
 parallel version of LAPACK and is used on Beowulf type clusters.

Package: libblacs-mpi-dev
Section: libdevel
Architecture: alpha amd64 arm64 armel armhf hppa hurd-i386 i386 kfreebsd-amd64 kfreebsd-i386 mips mips64el mipsel powerpc powerpcspe ppc64 ppc64el s390x sparc64 x32 m68k sh4
Depends: libblacs-openmpi1 (= ${binary:Version}) [alpha amd64 arm64 armel armhf hppa hurd-i386 i386 kfreebsd-amd64 kfreebsd-i386 mips mips64el mipsel powerpc powerpcspe ppc64 ppc64el s390x sparc64 x32],
         libblacs-mpich1 (= ${binary:Version}) [m68k sh4],
         mpi-default-dev, ${misc:Depends}
Replaces: blacs-mpi, blacs-mpich-dev, blacsgf-mpich-dev, blacs-lam-dev, blacsgf-lam-dev
Conflicts: blacs-mpi, blacs-mpich-dev, blacsgf-mpich-dev, blacs-lam-dev, blacsgf-lam-dev
Description: Basic Linear Algebra Comm. Subprograms - Dev. files for MPI
 The BLACS project is an ongoing investigation whose purpose is to
 create a linear algebra oriented message passing interface that may be
 implemented efficiently and uniformly across a large range of
 distributed memory platforms.
 .
 You can choose between an implementation based on MPI or PVM. This package
 uses MPI. There are packages for the shared libraries, for the static
 libraries and the development files (this one), and for test programs.
 .
 Most users do not need to install this package directly because it is
 used as a high level driver for the communication in the ScaLAPACK packages.
 Therefore, it is installed when installing ScaLAPACK. ScaLAPACK is a
 parallel version of LAPACK and is used on Beowulf type clusters.

Package: blacs-mpi-test
Section: math
Architecture: alpha amd64 arm64 armel armhf hppa hurd-i386 i386 kfreebsd-amd64 kfreebsd-i386 mips mips64el mipsel powerpc powerpcspe ppc64 ppc64el s390x sparc64 x32 m68k sh4
Depends: blacs-test-common, ${shlibs:Depends}, ${misc:Depends}
Replaces: blacs-mpich-test, blacsgf-mpich-test, blacs-lam-test, blacsgf-lam-test
Conflicts: blacs-mpich-test, blacsgf-mpich-test, blacs-lam-test, blacsgf-lam-test
Description: Basic Linear Algebra Comm. Subprograms - Test files for MPI
 The BLACS project is an ongoing investigation whose purpose is to
 create a linear algebra oriented message passing interface that may be
 implemented efficiently and uniformly across a large range of
 distributed memory platforms.
 .
 You can choose between an implementation based on MPI or PVM. This package
 uses MPI. There are packages for the shared libraries, for the static
 libraries and the development files, and for test programs (this one).
 .
 Most users do not need to install this package directly because it contains
 test programs for the BLACS libraries. You only need these if you experience
 problems with ScaLAPACK. The BLACS libraries are used as a high level
 communications library for ScaLAPACK. ScaLAPACK is a parallel version of
 LAPACK and is used on Beowulf type clusters.

Package: blacs-test-common
Section: math
Architecture: all
Depends: ${misc:Depends}
Description: Test data for BLACS testers
 The BLACS project is an ongoing investigation whose purpose is to
 create a linear algebra oriented message passing interface that may be
 implemented efficiently and uniformly across a large range of
 distributed memory platforms.
 .
 You can choose between an implementation based on MPI or PVM. This package
 provides test data for all BLACS packages (MPI and PVM versions).
 .
 Most users do not need to install this package directly because it is
 installed when installing the test programs for any BLACS package.

=== debian/rules ===
#! /usr/bin/make -f
# Made with the aid of debmake, by Christoph Lameter,
# based on the sample debian/rules file for GNU hello by Ian Jackson.
# Handmodified by P. Frauenfelder for debhelper support, 5 Sept 1998

topdir=$(shell pwd)

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# Read the MPI implementation provided by mpi-default-dev.
include /usr/share/mpi-default-dev/debian_defaults
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# This list of archs is maintained separately from that of the mpi-defaults
# package. If there is a mismatch between the two, the package will FTBFS. This
# is on purpose, to avoid silent breakage. See #740620 for more details.
OPENMPI_ARCHS=alpha amd64 arm64 armel armhf hppa hurd-i386 i386 kfreebsd-amd64 kfreebsd-i386 mips mips64el mipsel powerpc powerpcspe ppc64 ppc64el s390x sparc64 x32
MPICH_ARCHS=m68k sh4

# This list is to avoid the problem caused by Caught signal ‘Terminated’:
# terminating immediately in some build machines.

NO_TESTING = mips64el mipsel powerpc ppc64 sparc64 i386 alpha sh4
NO_TESTING_ARCH = $(shell dpkg-architecture -q DEB_BUILD_ARCH)
$(info NO_TESTING_ARCH is $(NO_TESTING_ARCH))

build-arch: build

build-indep: build

build: build-$(ARCH_DEFAULT_MPI_IMPL)

build-openmpi: build-stamp-openmpi check-stamp-openmpi

build-lam: build-stamp-lam check-stamp-lam

build-mpich: build-stamp-mpich check-stamp-mpich

build-mpich2: build-stamp-mpich2 check-stamp-mpich2

build-stamp-openmpi:
	dh_testdir
	[ -d TESTING/EXE ] || mkdir TESTING/EXE
# build the static libraries
	BASEDIR=$(topdir) MPI=openmpi make mpi
# the testing binaries
	cd TESTING && BASEDIR=$(topdir) \
	  BTLIBS='$$(BLACSFINIT) $$(BLACSLIB) $$(BLACSFINIT) $$(MPILIB)' \
	  BUILD=static MPI=openmpi make
# next is a clean
	BASEDIR=$(topdir) make cleanall
	cd TESTING && BASEDIR=$(topdir) make clean
# build the shared libraries
	BASEDIR=$(topdir) FPIC=-fPIC MPI=openmpi make mpi
	mkdir -p tmp
	set -e ;\
	for i in blacs blacsF77init blacsCinit ; do \
	  cd tmp ;\
	  ar x ../LIB/$${i}_MPI-LINUX-0.a ;\
	  mkdir -p tmp ;\
	  for j in $$(find -name "*.C") ;\
	    do mv $$j tmp/$$(echo $$j | sed 's,C$$,o,g') ;\
	  done;\
	  cd .. ;\
	  gcc -shared -Wl,-soname=lib$$i-openmpi.so.1 -o lib$$i-openmpi.so.1.1 \
	    $$(find tmp -name "*.o") $$(pkg-config mpi-fort --libs); \
	  ln -fs lib$$i-openmpi.so.1.1 lib$$i-openmpi.so.1 ;\
	  ln -fs lib$$i-openmpi.so.1 lib$$i-openmpi.so ;\
	  rm -f tmp/tmp/* ; rmdir tmp/tmp ; rm tmp/* ;\
	done
	rmdir tmp
# the testing binaries
	cd TESTING && BASEDIR=$(topdir) \
	  BTLIBS='-L.. -lblacsF77init-openmpi -lblacs-openmpi -lblacsF77init-openmpi $$(MPILIB)' \
	  BUILD=shared MPI=openmpi make

	touch build-stamp-openmpi

build-stamp-lam:
	dh_testdir
	[ -d TESTING/EXE ] || mkdir TESTING/EXE
# next is a clean
	BASEDIR=$(topdir) make cleanall
	cd TESTING && BASEDIR=$(topdir) make clean
# build the static libraries
	BASEDIR=$(topdir) MPI=lam make mpi
# the testing binaries
	cd TESTING && BASEDIR=$(topdir) \
	  BTLIBS='$$(BLACSFINIT) $$(BLACSLIB) $$(BLACSFINIT) $$(MPILIB)' \
	  BUILD=static MPI=lam make
# next is a clean
	BASEDIR=$(topdir) make cleanall
	cd TESTING && BASEDIR=$(topdir) make clean
# build the shared libraries
	BASEDIR=$(topdir) FPIC=-fPIC MPI=lam make mpi
	mkdir -p tmp
	set -e ;\
	for i in blacs blacsF77init blacsCinit ; do \
	  cd tmp ;\
	  ar x ../LIB/$${i}_MPI-LINUX-0.a ;\
	  mkdir -p tmp ;\
	  for j in $$(find -name "*.C") ;\
	    do mv $$j tmp/$$(echo $$j | sed 's,C$$,o,g') ;\
	  done;\
	  cd .. ;\
	  gcc -shared -Wl,-soname=lib$$i-lam.so.1 -o lib$$i-lam.so.1.1 \
	    $$(find tmp -name "*.o") -lmpi;\
	  ln -fs lib$$i-lam.so.1.1 lib$$i-lam.so.1 ;\
	  ln -fs lib$$i-lam.so.1 lib$$i-lam.so ;\
	  rm -f tmp/tmp/* ; rmdir tmp/tmp ; rm tmp/* ;\
	done
	rmdir tmp
# the testing binaries
	cd TESTING && BASEDIR=$(topdir) \
	  BTLIBS='-L.. -lblacsF77init-lam -lblacs-lam -lblacsF77init-lam $$(MPILIB)' \
	  BUILD=shared MPI=lam make

	touch build-stamp-lam

build-stamp-mpich:
	dh_testdir
	[ -d TESTING/EXE ] || mkdir TESTING/EXE
# next is a clean
	BASEDIR=$(topdir) make cleanall
	cd TESTING && BASEDIR=$(topdir) make clean
# build the static libraries
	BASEDIR=$(topdir) MPI=mpich make mpi
# the testing binaries
	cd TESTING && BASEDIR=$(topdir) \
	  BTLIBS='$$(BLACSFINIT) $$(BLACSLIB) $$(BLACSFINIT) $$(MPILIB)' \
	  BUILD=static MPI=mpich make
# next is a clean
	BASEDIR=$(topdir) make cleanall
	cd TESTING && BASEDIR=$(topdir) make clean
# build the shared libraries
	BASEDIR=$(topdir) FPIC=-fPIC MPI=mpich make mpi
	mkdir -p tmp
	set -e ;\
	for i in blacs blacsF77init blacsCinit ; do \
	  cd tmp ;\
	  ar x ../LIB/$${i}_MPI-LINUX-0.a ;\
	  mkdir -p tmp ;\
	  for j in $$(find -name "*.C") ;\
	    do mv $$j tmp/$$(echo $$j | sed 's,C$$,o,g') ;\
	  done;\
	  cd .. ;\
	  gcc -shared -Wl,-soname=lib$$i-mpich.so.1 -o lib$$i-mpich.so.1.1 \
	    $$(find tmp -name "*.o") -lmpich -lmpichfort;\
	  ln -fs lib$$i-mpich.so.1.1 lib$$i-mpich.so.1 ;\
	  ln -fs lib$$i-mpich.so.1 lib$$i-mpich.so ;\
	  rm -f tmp/tmp/* ; rmdir tmp/tmp ; rm tmp/* ;\
	done
	rmdir tmp
# the testing binaries
	cd TESTING && BASEDIR=$(topdir) \
	  BTLIBS='-L.. -lblacsF77init-mpich -lblacs-mpich -lblacsF77init-mpich $$(MPILIB)' \
	  BUILD=shared MPI=mpich make

	touch build-stamp-mpich

build-stamp-mpich2:
	dh_testdir
	[ -d TESTING/EXE ] || mkdir TESTING/EXE
# next is a clean
	BASEDIR=$(topdir) make cleanall
	cd TESTING && BASEDIR=$(topdir) make clean
# build the static libraries
	BASEDIR=$(topdir) MPI=mpich2 make mpi
# the testing binaries
	cd TESTING && BASEDIR=$(topdir) \
	  BTLIBS='$$(BLACSFINIT) $$(BLACSLIB) $$(BLACSFINIT) $$(MPILIB)' \
	  BUILD=static MPI=mpich2 make
# next is a clean
	BASEDIR=$(topdir) make cleanall
	cd TESTING && BASEDIR=$(topdir) make clean
# build the shared libraries
	BASEDIR=$(topdir) FPIC=-fPIC MPI=mpich2 make mpi
	mkdir -p tmp
	set -e ;\
	for i in blacs blacsF77init blacsCinit ; do \
	  cd tmp ;\
	  ar x ../LIB/$${i}_MPI-LINUX-0.a ;\
	  mkdir -p tmp ;\
	  for j in $$(find -name "*.C") ;\
	    do mv $$j tmp/$$(echo $$j | sed 's,C$$,o,g') ;\
	  done;\
	  cd .. ;\
	  gcc -shared -Wl,-soname=lib$$i-mpich2.so.1 -lmpich -o lib$$i-mpich2.so.1.1 \
	    $$(find tmp -name "*.o");\
	  ln -fs lib$$i-mpich2.so.1.1 lib$$i-mpich2.so.1 ;\
	  ln -fs lib$$i-mpich2.so.1 lib$$i-mpich2.so ;\
	  rm -f tmp/tmp/* ; rmdir tmp/tmp ; rm tmp/* ;\
	done
	rmdir tmp
# the testing binaries
	cd TESTING && BASEDIR=$(topdir) \
	  BTLIBS='-L.. -lblacsF77init-mpich2 -lblacs-mpich2 -lblacsF77init-mpich2 $$(MPILIB)' \
	  BUILD=shared MPI=mpich2 make

	touch build-stamp-mpich2

check-stamp-openmpi:

ifneq ($(filter $(NO_TESTING_ARCH),$(NO_TESTING)),)
	touch check-stamp-openmpi
else
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	 dh_testdir
	if [ -x /usr/bin/mpiexec.openmpi ]; then \
    	  (cd TESTING/EXE; for i in *-openmpi; do \
    	    echo "Running test $$i"; \
    	    LD_LIBRARY_PATH=../../ mpiexec.openmpi -np 4 ./$$i > $$i.log 2>&1 ; \
    	    grep FAILED $$i.log | sed s/DOUBLE// | \
    	    awk '{total += $$4; passed += $$6; skipped += $$8; failed += $$10} END \
    	      {print "total: " total " passed: " passed " skipped: " skipped " failed: " failed ; \
    	      if (failed > 0) {exit 1}}' ; \
    	  done) \
    	fi
    endif
	touch check-stamp-openmpi
endif

check-stamp-lam:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_testdir
	if [ -x /usr/bin/mpiexec.lam ]; then \
	  (cd TESTING/EXE; for i in *-lam; do \
	    echo "Running test $$i"; \
	    LD_LIBRARY_PATH=../../ mpiexec.lam -np 4 ./$$i > $$i.log 2>&1 ; \
	    grep FAILED $$i.log | sed s/DOUBLE// | \
	    awk '{total += $$4; passed += $$6; skipped += $$8; failed += $$10} END \
	      {print "total: " total " passed: " passed " skipped: " skipped " failed: " failed ; \
	      if (failed > 0) {exit 1}}' ; \
	  done) \
	fi
endif
	touch check-stamp-lam

check-stamp-mpich:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
